unit editpole;
{$I defines.inc}
{$I-,B-,R-}

{TODO: 
Spojov seznam dk by nenesl dnou informaci o Y1 a Y2 a patrn ani ne o slu dku.
Tyhle funkce by pevzala nov struktura, kter by dan daje udrovala pouze pro zobrazovanou oblast na obrazovce.
}

interface
uses Dos,Objects,Vaznik,TEdRadky,Wokna32,VenomGFX,Lacrt,FNfont2,RezKlav;

const
    edna_OK       = 0;
    edna_NOFILE   = 1;
    edna_CANCELED = 2;


type
Tkurpoz = record
   x,y:longint;     {Y=cislo radky;X=znak v radku (v unicode nemusi platit 1bajt=1znak)}
   r:PUzel;         {na nem bude PEdRadek tzn. ukazatel na radek s kurzorem}
end;


TBlokTextu = object
radkybloku:PVaznik;
Constructor Init;
Procedure VlozBlok(zac,kon:TKurPoz); {zdroj textu se bere ze ZAC.R a kon.R}
Procedure SmazObsah;
Destructor Done;virtual;
end;



PEditacniPole = ^TEditacniPole;
TEditacniPole = object(TWoknaZaklad)
       radky:PVaznik;      {jsou tam navazany typy PEdRadek}
       pozice:TKurpoz;
       posledni_vyskyt:TKurpoz;
       PozText:record
          odz,doz,
          posunv,posunm:longint;
          end;
       konverze_tagu:boolean;
       jednotna_vyska_radku:boolean;
       unicode:boolean;
       povolene_zmeny:boolean;
       {true=kdyz nacita soubor, tak zdvojuje vsechny znaky "<", aby se neinterpretovaly
       jako tagy. Pri ukladani je zase naopak odmazava.
       false=u nacitaneho souboru predpoklada, ze tagy obsahuje, takze zadne konverze nedela
       Default je TRUE}
       vsirka:longint;        {"cista" sirka, t.j. sirka bez posuvniku}
       kx,ky,kd:longint;      {X a Y poloha kurzoru a jeho vyska}
       kkx,kky:longint;
       kpoz:virtualwindow;
       odz,doz:longint;       {na radku s kurzorem jsou vypsany znaky od ODZ do DOZ}
       virt:PVirtualWindow;
       BB_txt_v,BB_txt_txt:word; {pozadi a popredi textu}

       poc_zobrX,poc_zobrY:longint;    {posun virtualni obrazovky (pro rizeni scrollingu)}

       po_kl_pozice:TKurpoz;       {sem si ulozim pozici kurzoru pred odjetim posuvnikem}
       po_kl_poc_zobrX,po_kl_poc_zobrY:longint; {uschova scrolovatek}
       po_kl_jsme_mimo:boolean;
       po_kl_rozpr:boolean;{posuvniko-klavesovy rozpor}

       prv_rad,posl_rad:PUzel;       {Prvni a posledni vypsany radek}
       po_kl_prv_rad,po_kl_posl_rad:PUzel; {a jejich uschova}
       tot_posl:PUzel;                 {Uplne posledni radka souboru}
       py:PPosuvnik;
       puvodni_citac:dword;
       je_videt:boolean;      {je zrovna videt kurzor?}
       rychlost_blikani:byte;
       zalamuj:boolean;       {ma zalamovat radky?}
       tab_na_mezery:byte;
       byla_zmena:boolean;
       ED_key_proc:Function(o:kevent):kevent;
       ED_zobr_proc:Procedure;
       ukaz_postup_nahravani:Function(r:real):boolean;
       mimoradne_osetreni_klavesnice:Function(o:kevent):string;
       prac1,prac2:longint;
       sx,svx,sy:longint;     {zaloha polohy kurzoru}
       sr:PUzel;              {nekdy se to muze hodit}
       Constructor Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
       Procedure Zobraz;virtual;
       procedure Kontrola;virtual;
       Function NactiSoubor(s:string):byte;
       {edna_OK = vse v poradku, edna_NOFILE = neexistujici soubor,
        edna_CANCELED = zrusene nacitani}
       Function UlozSoubor(s:string):boolean;
       Function NactiZeStreamu(var s:TStream):byte;
       Function UlozDoStreamu(var s:TStream):boolean;
       Function NactiZVazniku(p:PVaznik):boolean;
       {Na vaznik jsou pripojeny PStringy}
       Procedure EP_UberVetsi(v:PItRadek);
       Procedure EP_PridejVetsi(v:PItRadek);
       Procedure EP_ZavriSoubor;
       Procedure ZkusZrusitRozpr;
       Procedure Prilep_K_predeslemu(pr:PUzel;smezerou:boolean);
       Procedure NalamejBuffer(pr:PUzel);
       Procedure PosunRadek(p:PUzel);
       Function MoznyPreskokNahoru:boolean;
       Procedure PridejTextNaPoziciKurzoru(kp:PChar;ksd:longint);
       Procedure NastavRozmeziRadku(v:PItRadek;var yz:longint);
       Procedure UpravRozmeziRadku(v:PItRadek;var yz:longint);
       Procedure PospojujRadky;
       Procedure PridelRadky;
       Procedure PreskladejRadky(poz:TKurPoz);
       Procedure PreskladejRadky(poz:TKurPoz;m1,m2,m3:boolean);
       Procedure VycentrujNaKurzor;
       Procedure horz_VycentrovaniKurzoru;
       Procedure vert_VycentrovaniKurzoru;
       Procedure ZmenFont(s:string);
       Procedure PresunKurzor_na_grafickou_pozici(xx,yy:longint;var kur:TKurPoz);
       Function UkazatelNaRadku(n:longint):PUzel;
       Procedure OverPoziciKurzorovehoBodu(var kur:TKurPoz);
       Function DejLinearniPozici:longint;
       Procedure NastavLinearniPozici(i:longint);
       Procedure PosouvaciRezim;
       Procedure ZalamovaciRezim;
       Procedure ZmenBarvuPozadi(w:word);
       Procedure BlikejKurzorem;
       Procedure ZhasniKurzor;
       Procedure RozsvitKurzor;
       Procedure RozdelRadku(poz:TKurPoz;var posun:longint);
       Procedure DalsiRadka(u:PChar;poz:longint;ukoncena:boolean);
       Function PismenoZpet:longint;
       Procedure SmazRadku(var poz:TKurPoz);
       Procedure SmazRadku(var poz:TKurPoz;moznosunout:boolean);
       Procedure SmazCastRadky(poz1,poz2:TKurpoz);
       Procedure SmazSlovo;
       Procedure SmazBlokTextu(zac,kon:TKurPoz);
       Procedure VlozTextNaPozici(blok:PVaznik;poz:TKurPoz);
       Procedure SkocNaZacatek;
       Procedure NovySoubor;
       Procedure poc_zobrY_dle_posuvniku;
       procedure OsetriVstup(var chceme_zobrazit:boolean);
       Function KrokVpred:longint;
       Function KrokZpet:longint;
       Procedure SipkaDolu;
       Procedure SipkaNahoru;
       Procedure BackSpace;
       Procedure KlavesaDel;
       Procedure KlavesaEnter;
       Procedure KlavesaPGDN;
       Procedure KlavesaPGUP;
       Procedure KlavesaCtrlPGUP;
       Procedure KlavesaCtrlPGDN;
       Procedure KlavesaEnd;
       Procedure KlavesaHome;
       Procedure ZpracujPraveMysitko(nx,ny:longint;kur:TKurPoz);virtual;
       Procedure ZpracujStredniMysitko(nx,ny:longint;kur:TKurPoz);virtual;
       Procedure ZpracujLeveMysitko(nx,ny:longint;kur:TKurPoz);virtual;
       Procedure ZpracujKoleckoMysi(var chceme_zobrazit:boolean);virtual;
       Function ZkontrolujYY:boolean;

       Destructor Done;virtual;
       end;

Procedure TextoveOkno(x,y,sirka,vyska:longint;popis:string;p:string);

implementation
const SKOKOVY_POSUN_POC_ZOBRX = 160;
{var font:fn;}

Procedure Dummy;begin end;

Function Default_ed_key_proc(o:kevent):kevent;
begin
Default_ed_key_proc:=o;
end;

Constructor TEditacniPole.Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
var hv:boolean;
     r:PItRadek;
     a:longint;
    _virt:Virtualwindow;
begin
inherited init;
id:=id_TEditacniPole;
automys:=false;
x:=ix; y:=iy;
radky:=New(PVaznik,Init);
r:=New(PItRadek,Init);
radky^.InitNext(r);
r^.y1:=0;
r^.y2:=Vyska_FN_default-1;
r^.yy:=1;
if iakt then Aktivuj else Deaktivuj;
pozice.x:=1;             {kurzor bude na 1.znaku radku}
pozice.y:=1;             {a na 1.radku}
pozice.r:=radky^.first;  {ukazatel na udaje radku}
tot_posl:=pozice.r;      {uplne posledni radka je zaroven prvni radkou}
posledni_vyskyt.r:=nil;
odz:=0;
doz:=0;          {na aktualnim radku se nam prave zobrazuje nulty az nulty znak :-)}
poc_zobrX:=4;    {od ktere X-ove souradnice okna ma zacit vykreslovat radky}
poc_zobrY:=0;    {...a od ktere Y-ove}

vyska:=vyska;
sirka:=sirka;

py:=ZalozVertikalniPosuvnikOkna(x,y,sirka,vyska,vyska,vsirka);

po_kl_rozpr:=false;      {posuvniko-klavesovy rozpor}
konverze_tagu:=true;     {pri nacitani zdvojuj znaky "<"}
povolene_zmeny:=true;    {text smi byt menen}
jednotna_vyska_radku:=true; {neni treba zkoumat text radku, vime predem, jak bude vysoky}
unicode:=false;          {nepouzivame rezim unicode}
zalamuj:=false;          {defaultne zalamovat radky nebudu}
mimoradne_osetreni_klavesnice:=nil;
ED_key_proc:=@Default_ed_key_proc;
ED_zobr_proc:=@Dummy;
ukaz_postup_nahravani:=nil;
Init_VW(_virt,sirka,vyska,false);
virt:=@_virt;
hlavni_font:=FN_syst_font;
ofn:=FN_default;
kx:=4;           {pocatecni poloha a delka kurzoru}
kkx:=-1;
ky:=0;
kd:=Vyska_FN_default;
kpoz.hoehe:=kd;
Init_VW(kpoz,1,100,false);

BB_txt_v:=BA_txt_v;
BB_txt_txt:=BA_txt_txt;

Clr(virt^,BB_txt_v);
puvodni_citac:=0;
je_videt:=false;      {je zrovna videt kurzor?}
rychlost_blikani:=10;
tab_na_mezery:=5;
byla_zmena:=false;
end;


Procedure TEditacniPole.poc_zobrY_dle_posuvniku;
begin
if po_kl_rozpr=false then
   begin
   po_kl_pozice:=pozice;  {zapamatuju si momentalni polohu kurzoru}
   po_kl_poc_zobrx:=Poc_ZobrX;
   po_kl_poc_zobry:=Poc_ZobrY;
   po_kl_prv_rad:=prv_rad;
   po_kl_posl_rad:=posl_rad;
   if je_videt then BlikejKurzorem;
   po_kl_rozpr:=true;
   (*PutClippedSprite(cil^,kpoz,kkx,kky);  {chvilkove vypnuti kurzoru}*)
   end;
if py<>nil then Poc_ZobrY:=py^.hodnota;
end;


procedure TEditacniPole.ZpracujPraveMysitko(nx,ny:longint;kur:TKurPoz);
begin
MouseRel;
end;

procedure TEditacniPole.ZpracujStredniMysitko(nx,ny:longint;kur:TKurPoz);
begin
MouseRel;
end;


Procedure TEditacniPole.ZpracujLeveMysitko(nx,ny:longint;kur:TKurPoz);
begin
pozice:=kur;
po_kl_rozpr:=false;  {levym mysitkem se odstrani posuvniko-klavesovy rozpor}
MouseRel;
end;


Procedure TEditacniPole.ZpracujKoleckoMysi(var chceme_zobrazit:boolean);
begin
if mouse._wdif=0 then exit;
if py<>nil then
   begin
   py^.Posun(py^.hodnota+mouse._wdif*20);
   poc_zobrY_dle_posuvniku;
   chceme_zobrazit:=true;
   end;
mouse._wdif:=0;
end;


Procedure TEditacniPole.PresunKurzor_na_grafickou_pozici(xx,yy:longint;var kur:TKurPoz);
var v:PItRadek;
    p,dumm:PUzel;
begin
p:=prv_rad;          {prvni realne na obrazovce vypsana radka}
while p<>nil do
   begin
   v:=p^.vazba;
   if (yy>=v^.y1) and (yy<=v^.y2) then
      begin
      kur.y:=v^.yy;
      kur.x:=Pozice_v_retezci_IT(xx,poc_zobrX,v,dumm);
      kur.r:=p;
      Exit;
      end;
   p:=p^.dalsi;
   end;
{Pokud jsme se dostali az sem, tak to znamena, ze jsme klikli az
 pod posledni radku do volneho prostoru}
p:=tot_posl;
v:=p^.vazba;
kur.y:=v^.yy;
kur.x:=Pozice_v_retezci_IT(xx,poc_zobrX,v,dumm);
kur.r:=p;
end;


procedure TEditacniPole.kontrola;
   Procedure KlepnutiMysi;
   var op,p:pvaznik;
       v:PItRadek;
       mx,my:longint;
       b:integer;
       kur:TKurPoz;

   begin
   if povolene_zmeny=false then Exit;
   b:=mouse.b;
   if b=0 then Exit;
   if (not Uvnitr(Mouse.last_px,Mouse.last_py,x,y,x+sirka,y+vyska)) then Exit;

   {dodatecna kontrola. kdyby nebyla, mohlo by pri manipulaci zvnejsku s
    promennymi STAV a XM a YM dochazet v teto procedure k neplecham}
   mx:=mouse.x-x;
   my:=mouse.y-y+poc_zobrY;

   PresunKurzor_na_grafickou_pozici(mx,my,kur);
   if b=1 then ZpracujLeveMysitko(mx,my,kur);
   if b=2 then ZpracujPraveMysitko(mx,my,kur);
   if b=4 then ZpracujStredniMysitko(mx,my,kur);
   end;

var i:longint;
    d:dword;
    zmena_bliknuti,chceme_zobrazit:boolean;

Begin
inherited kontrola;

{zmena_bliknuti:=false;
d:=FromTimer;
if d>puvodni_citac+rychlost_blikani then
   begin
   je_videt:=not(je_videt);
   puvodni_citac:=d;
   zmena_bliknuti:=true;
   end;}


zmena_bliknuti:=false;
{extra_udalost:=0;}
d:=FromTimer;
if d>puvodni_citac+rychlost_blikani then
   begin
   puvodni_citac:=d;
   zmena_bliknuti:=true;
   {zmena:=true;}
   end else zmena_bliknuti:=false;

case stav of
   _deaktivace:begin
      stav:=_neaktivni;                 {odted jsme neaktivni}
      if Je_videt then BlikejKurzorem;  {vypni kurzor}
      Zobraz;                           {zobraz neaktivni variantu}
      end;

   _aktivace:begin
      stav:=_aktivni;                   {odted jsme aktivni}
      MouseRel;                         {pockej na pusteni mysi}
      Zobraz;
      end;

   _aktivni:begin
     if zmena_bliknuti then BlikejKurzorem;
      chceme_zobrazit:=false;
      py^.kontrola;
      if py^.kopozitiv then
         begin
         poc_zobrY_dle_posuvniku;
         Zobraz;
         zmena:=false;
         Exit;
         end;

      if Mouse.B<>0 then    {pokud je zmacknuto mysitko, jdeme rest mys}
         begin
         PutClippedSprite(cil^,kpoz,kkx,kky);  {chvilkove vypnuti kurzoru}
         KlepnutiMysi;
         je_videt:=true;puvodni_citac:=FromTimer;BlikejKurzorem;
         end;

      ZpracujKoleckoMysi(chceme_zobrazit);

      if Mouse.B=0 then     {pokud je mys volna, tak se zajimame o klavesy}
         OsetriVstup(chceme_zobrazit);
      if chceme_zobrazit then Zobraz;
      end;

   _neaktivni:begin
      {nedelej nic}
      end;
end;{case}
zmena:=false;
end;



{Mozna by bylo lepsi presunout nasledujici dve funkce do FNFONT2.PAS...}
Function TEditacniPole.KrokZpet:longint;
begin
if pozice.x<=1 then Exit(0);
dec(pozice.x);
if PozText.odz<>0 then         {presahuje tento radek levy okraj obrazovky?}
   if pozice.x<=PozText.odz then
      inc(poc_ZobrX,-PozText.posunm);
KrokZpet:=0;
end;

Function TEditacniPole.KrokVpred:longint;
var v:PItRadek;
begin
v:=pozice.r^.vazba;
if pozice.x>v^.up then Exit(0);
inc(pozice.x);
if PozText.doz<>0 then         {presahuje tento radek pravy okraj obrazovky?}
   if pozice.x-1>=PozText.doz then dec(poc_zobrX,PozText.posunv);
KrokVpred:=0;
end;

Procedure TEditacniPole.SipkaDolu;
var  v:PItRadek;
     dumm:PUzel;
     a1,a2:longint;
begin
if po_kl_rozpr and po_kl_jsme_mimo then
   begin
   v:=po_kl_prv_rad^.vazba;
   pozice.r:=po_kl_prv_rad;
   pozice.y:=v^.yy;
   poc_zobrY:=po_kl_poc_zobrY;
   poc_zobrX:=po_kl_poc_zobrX;
   end;
if povolene_zmeny then
   begin
   if pozice.y>=Radky^.pocet then Exit;
   inc(pozice.y);
   pozice.r:=pozice.r^.dalsi;
   v:=pozice.r^.vazba;
   pozice.x:=Pozice_v_retezci_IT(kx,poc_zobrX,v,dumm);

   {if pozice.x<v^.spp+1 then inc(pozice.x);}
   {Bude potreba zascrolovat?}
   if FN_poz_v_ret_delka_radky<-poc_zobrX then  {horizontalni scrolling}
      begin
      poc_zobrX:=-FN_poz_v_ret_delka_radky+virt^.breite div 4;
      if poc_zobrX>4 then poc_zobrX:=4;
      end;
   if v^.y2>poc_ZobrY+virt^.hoeheminus1 then     {vertikalni scrolling}
      poc_ZobrY:=v^.y2-virt^.hoeheminus1+1;   {pozor HOEHEMINUS1 neni totez co HOEHE}
   end
   else begin
   v:=tot_posl^.vazba;
   inc(poc_ZobrY,py^.tlacitkovy_skok);
   if poc_ZobrY>v^.y2-virt^.hoeheminus1 then
      poc_ZobrY:=v^.y2-virt^.hoeheminus1;
   end;
end;

Procedure TEditacniPole.SipkaNahoru;
var  v:PItRadek;
     dumm:PUzel;
begin
if po_kl_rozpr and po_kl_jsme_mimo then
   begin
   v:=po_kl_posl_rad^.vazba;
   pozice.r:=po_kl_posl_rad;
   pozice.y:=v^.yy;
   poc_zobrY:=po_kl_poc_zobrY;
   poc_zobrX:=po_kl_poc_zobrX;
   end;
if povolene_zmeny then
   begin
   if pozice.y<=1 then Exit;
   dec(pozice.y);
   pozice.r:=pozice.r^.predchozi;
   v:=pozice.r^.vazba;
   pozice.x:=Pozice_v_retezci_IT(kx,poc_zobrX,v,dumm);
   {if pozice.x<v^.spp+1 then inc(pozice.x);}
   {Bude potreba zascrolovat?}
   if FN_poz_v_ret_delka_radky<-poc_zobrX then  {horizontalni scrolling}
      begin
      poc_zobrX:=-FN_poz_v_ret_delka_radky+virt^.breite div 4;
      if poc_zobrX>4 then poc_zobrX:=4;
      end;
   if v^.y1<poc_ZobrY then                      {vertikalni scrolling}
      poc_ZobrY:=v^.y1;
   end
   else begin
   dec(poc_ZobrY,py^.tlacitkovy_skok);
   if poc_ZobrY<0 then
      poc_ZobrY:=0;
   end;

end;

Procedure TEditacniPole.Prilep_K_predeslemu(pr:PUzel;smezerou:boolean);
var p:PUzel;
    v,v2:PItRadek;

begin
p:=pr^.predchozi;
if pr=tot_posl then {jestli rusim posledni radek, tak musim TOT_POSL preznacit}
   tot_posl:=p;
v2:=p^.vazba;
v:=pr^.vazba;
if smezerou then v2^.Vloz(' ',1,v2^.up+1);

if pozice.r=pr then          {kurzor je na prilepovanem radku?}
   begin
   pozice.r:=p;                 {presunu ho na predchozi radek}
   dec(pozice.y);
   pozice.x:=v2^.up+pozice.x; {a prepocitam X-ovou souradnici}
   end;

if posledni_vyskyt.r=pr then
   posledni_vyskyt.r:=nil;   {meni se tu rozlozeni radek. Tezko by se to}
                             {hlidalo poradne, tak aspon zrusim zaznam o posl.}
                             {vyskytu}

v2^.Vloz(v^.p,v^.up,v2^.up+1);
inc(v2^.gd,v^.gd);
v2^.crlf:=v^.crlf;
Dispose(v,Done);

Radky^.Zrusuzel(pr);
end;

Function DelkaPrvnihoSlova(p:PUzel;var poz:longint):longint;
var i,j:longint;
    q:pchar;
    v2:PItRadek;
begin
v2:=p^.vazba;
q:=v2^.p;
i:=v2^.Najdi(' ',1);
poz:=i;
if {i=0}i<=1 then Exit(0);
j:=SirkaUseku_IT(v2,1,i-1);
DelkaPrvnihoSlova:=j;
end;

Procedure TEditacniPole.BackSpace;
var l,a,b:longint;
    v,v2:PItRadek;
    p:PUzel;
    n:Pchar;
    s:string;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
if pozice.x=1 then if pozice.y=1 then Exit else
   begin
   p:=pozice.r^.predchozi;
   v2:=p^.vazba;

   a:=Sirka_IT(v2);

   Prilep_K_predeslemu(p^.dalsi,false); {soucasne upravi kurzor}

   if (zalamuj=false) then
      begin
      if a>virt^.breiteminus1 then
         poc_zobrX:=-(a-virt^.breiteminus1)-virt^.breite div 4;
      PosunRadek(p^.dalsi);
      {Bude potreba zascrolovat?}
      if v2^.y1<poc_ZobrY then {jo}
         poc_ZobrY:=v2^.y1;
      end
      else begin
      while v2^.crlf<>true do Prilep_k_predeslemu(p^.dalsi,true);
      NalamejBuffer(p);
      end;
   Exit;
   end;


KrokZpet;
v^.Vyjmi(pozice.x,1);

if zalamuj {and (v^.crlf=false) and (pozice.r<>tot_posl)} then
   begin
   {napred ke stavajicimu radku pripojim radky nasledujici}
   while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true);

   {a navic jeste musim zkusit pripojit tento radek k predchazejicimu}
   p:=pozice.r^.predchozi;
   if p^.predchozi=nil then p:=p^.dalsi;
   v:=p^.vazba;
   while v^.crlf=false do Prilep_k_predeslemu(p^.dalsi,true);
   v^.gd:=virt^.breite;
   {a ted to vsechno nalamu}
   NalamejBuffer(p);
   end;
end;

Procedure TEditacniPole.KlavesaDel;
var l,a,b:longint;
    v,v2:PItRadek;
    p:PUzel;
    s:string;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
if (pozice.x<v^.up+1) then
   begin
   v^.Vyjmi(pozice.x,1);
   if (zalamuj=true) and (v^.crlf=false) and (pozice.r<>tot_posl) then
      begin
      a:=DelkaPrvnihoSlova(pozice.r^.dalsi,b);
      b:=virt^.breiteminus1-4-v^.gd;
      if b>a then
         begin
         while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true);
         NalamejBuffer(pozice.r);
         end;
      end;
   end
   else if pozice.r=tot_posl then Exit else
   begin
   p:=pozice.r^.dalsi;
   if p=tot_posl then     {jestlize zrusim posledni radek, tak musim preznacit}
      tot_posl:=pozice.r; {TOT_POSL}
   v2:=p^.vazba;
   Prilep_K_predeslemu(p,false); {Pozor, muze hybat s promennou POZICE}
   if zalamuj then
      begin
      while v^.crlf=false do Prilep_K_predeslemu(pozice.r^.dalsi,true);
      NalamejBuffer(pozice.r);
      end else PosunRadek(pozice.r^.dalsi);
   Exit;
   end;
end;


Procedure TEditacniPole.RozdelRadku(poz:TKurPoz;var posun:longint);
var v,v2:PItRadek;
    p,q:PUzel;
begin
v:=poz.r^.vazba;
v2:=New(PItRadek,Init);        {novy prazdy PItRadek}

p:=Radky^.InsertNew(poz.r,v2); {zapojim ho do retezu a vygeneruju novy uzel}

if poz.r=tot_posl then {jesltli jsme na uplne poslednim radku souboru}
   tot_posl:=p;           {a vytvorim novy, tak musim aktualizovat TOT_POSL}

v^.Rozdel(v2^,poz.x,0);
v^.crlf:=true;
posun:=v^.y2-v^.y1+1;      {BETA - zatim predpokladam, ze nikde neni zmena vysky fontu}
v2^.y1:=v^.y1;
v2^.y2:=v^.y2;
v2^.yy:=v^.yy;
v2^.crlf:=v^.crlf;
end;


Procedure TEditacniPole.KlavesaEnter;
var v,v2:PItRadek;
    p,q:PUzel;
    n:PChar;
    a:longint;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;

RozdelRadku(pozice,a);

pozice.x:=1;           {po zmacknuti Enteru budeme urcite na prvnim sloupci}
inc(pozice.y);
Poc_ZobrX:=4;

v:=pozice.r^.vazba;

p:=pozice.r^.dalsi; {nove vznikly radek}
v2:=p^.vazba;

if (zalamuj=false) {or (v^.crlf=true)} then PosunRadek(p)
   else begin
   {zalamovani}
   if pozice.y>2 then
      begin
      pozice.r:=p;
      q:=p^.predchozi^.predchozi;
      v:=q^.vazba;
      v^.gd:=virt^.breite;
      if v^.crlf=false then Prilep_k_predeslemu(p^.predchozi,true);
      end else q:=pozice.r;
   while v2^.crlf=false do Prilep_K_predeslemu(p^.dalsi,true);
   v2^.gd:=virt^.breite;
   NalamejBuffer(q);
   end;

pozice.r:=p;           {neboli pozice.r:=pozice.r^.dalsi}
{v^.crlf:=true;}

{Bude potreba zascrolovat?}
if v2^.y2>poc_ZobrY+virt^.hoeheminus1 then {jo}
   poc_ZobrY:=v2^.y2-virt^.hoeheminus1+1;
end;

Procedure TEditacniPole.KlavesaPGDN;
var v:PItRadek;
    p,op:PUzel;
    l:longint;
    b:boolean;
begin
if po_kl_rozpr and po_kl_jsme_mimo then begin SipkaNahoru;Exit;end;
b:=false;
if posl_rad^.dalsi=nil then b:=true else
   begin
   v:=posl_rad^.dalsi^.vazba;
   if v^.y2-poc_ZobrY<virt^.hoehe then b:=true;
   posl_rad:=posl_rad^.dalsi;
   end;
if B then
   begin
   v:=posl_rad^.vazba;
   inc(pozice.y,v^.yy-pozice.y{+1}{posl_od_poz+1});
   pozice.r:=posl_rad;
   pozice.x:=Pozice_v_retezci_IT(kx+poc_ZobrX,poc_zobrX,v,nil);
   Exit;
   end;
posl_rad:=posl_rad^.predchozi;   {mirne pofiderni...}
v:=posl_rad^.vazba;
l:=ky-poc_zobrY+v^.y1;
poc_zobrY:=v^.y1;

{Mame posunuto. Ted je potreba zjistit, kde se vlastne nachazi kurzor}
p:=posl_rad;
while p<>nil do        {udelam scan od shora dolu...}
   begin
   v:=p^.vazba;
   if v^.y2>l then    {kurzor je na tehle radce}
      begin
      pozice.x:=Pozice_v_retezci_IT(kx+poc_ZobrX,poc_ZobrX,v,nil);
      {if pozice.x<v^.up+1 then inc(pozice.x);}
      pozice.y:=v^.yy;
      pozice.r:=p;
      Exit;
      end;
   op:=p;
   p:=p^.dalsi;
   end;
{sem bychom se nikdy nemeli dostat, nicmene sem neco napisu...}
pozice.x:=1;
pozice.r:=op;
pozice.y:=v^.yy;
end;

Procedure TEditacniPole.KlavesaPGUP;
var l,m:longint;
    v:PItRadek;
    p,op:PUzel;
begin
if po_kl_rozpr and po_kl_jsme_mimo then begin SipkaDolu;Exit;end;

if prv_rad^.predchozi^.predchozi=nil then
   begin
   pozice.y:=1;
   pozice.r:=radky^.first;
   poc_ZobrY:=0;
   Exit;
   end;

v:=prv_rad^.vazba;
l:=ky-poc_zobrY;
dec(poc_zobrY,virt^.hoehe-(v^.y2-v^.y1+1));
p:=prv_rad;                    {jemne doladeni}
while p^.predchozi<>nil do
   begin
   v:=p^.vazba;
   if v^.y1-poc_zobrY=0 then Break;
   if v^.y1-poc_zobrY<0 then
      begin
      poc_zobrY:=v^.y2+1;      {neprilis ciste :-(}
      Break;
      end;
   p:=p^.predchozi;
   end;
if poc_zobrY<0 then poc_zobrY:=0;

{Mame posunuto. Ted je potreba zjistit, kde se vlastne nachazi kurzor}
l:=l+poc_ZobrY;

if povolene_zmeny then
   begin
   p:=prv_rad;
   while p<>nil do             {provedu scan zdola nahoru}
      begin
      v:=p^.vazba;
      if v^.y1<=l then
         begin
         pozice.x:=Pozice_v_retezci_IT(kx+poc_ZobrX,poc_zobrX,v,nil);
         {if pozice.x<v^.up+1 then inc(pozice.x);}
         pozice.y:=v^.yy;
         pozice.r:=p;
         Exit;
         end;
      p:=p^.predchozi;
      end;
   end;

{Nasledujici kod by se mel vykonat jenom v pasivnim modu}
pozice.x:=1;
pozice.y:=1;
pozice.r:=radky^.first;
end;

Procedure TEditacniPole.KlavesaCtrlPGUP;
begin
SkocNaZacatek;
end;

Procedure TEditacniPole.KlavesaCtrlPGDN;
var v:PItRadek;
begin
pozice.x:=1;
pozice.r:=tot_posl;
v:=tot_posl^.vazba;
pozice.y:=v^.yy;
VycentrujNaKurzor;
end;

Procedure TEditacniPole.KlavesaEND;
var v:PItRadek;
    a:longint;
begin
v:=pozice.r^.vazba;
pozice.x:=v^.delka+1;
if v^.gd>virt^.breiteminus1-poc_ZobrX then
   Poc_ZobrX:=-(v^.gd-virt^.breiteminus1+4);
end;

Procedure TEditacniPole.KlavesaHome;
var p:PItRadek;
begin
pozice.x:=1;
Poc_ZobrX:=4;
end;

Function TEditacniPole.MoznyPreskokNahoru:boolean;
var v:PItRadek;
    p:PUzel;
    i,j:longint;
begin
MoznyPreskokNahoru:=false;
if pozice.y<=1 then Exit;
p:=pozice.r^.predchozi;
v:=p^.vazba;
if v^.crlf then Exit;

i:=DelkaPrvnihoSlova(pozice.r,j);
if j<>pozice.x-1 then Exit;
j:=virt^.breiteminus1-v^.gd-4;
if i<j then
   begin
   Prilep_k_predeslemu(p^.dalsi,true);
   v^.gd:=virt^.breite;
   MoznyPreskokNahoru:=true;
   end;
end;

Procedure TEditacniPole.PridejTextNaPoziciKurzoru(kp:PChar;ksd:longint);
var v:PItRadek;
    i:longint;
    b:boolean;
begin
if povolene_zmeny=false then Exit;
if kp[0]=#0 then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
v^.Vloz(kp,ksd,pozice.x);
inc(pozice.x,ksd);
if pozice.x=v^.up+1 then          {piseme na konci radku?}
   begin
   inc(i,kx);
   if i>virt^.breiteminus1 then
      dec(poc_zobrX,{i-virt^.breiteminus1}SKOKOVY_POSUN_POC_ZOBRX);
      end else
      if PozText.doz<>0 then         {presahuje tento radek pravy okraj obrazovky?}
         if pozice.x-1>=PozText.doz then dec(poc_zobrX,{PozText.posunv}SKOKOVY_POSUN_POC_ZOBRX);

   if zalamuj then
      begin
      poc_zobrX:=4;
      if kp^=' ' then b:=MoznyPreskokNahoru else b:=false;
      v:=pozice.r^.vazba;
      if v^.gd>virt^.breiteminus1-4 then
         begin
         while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true{false});
         NalamejBuffer(pozice.r);
         end;
      {if B then
         begin
         pozice.x:=1;
         inc(pozice.y);
         pozice.r:=pozice.r^.dalsi;
         end;}
      end;
end;

Procedure TEditacniPole.ZkusZrusitRozpr;
var p:PUzel;
begin
if po_kl_jsme_mimo then
   begin
   swap(poc_zobrX,po_kl_poc_zobrX);
   swap(poc_zobrY,po_kl_poc_zobrY);
   p:=prv_rad;prv_rad:=po_kl_prv_rad;po_kl_prv_rad:=p;
   p:=posl_rad;posl_rad:=po_kl_posl_rad;po_kl_posl_rad:=p;
   end
   else begin
   horz_VycentrovaniKurzoru;
   end;
end;

Procedure TEditacniPole.OsetriVstup(var chceme_zobrazit:boolean);
var o:kevent;
    i,ksd:longint;
    kp:pchar;
    ks:string[20];
    r:char;
begin
ks:='';
  if xKeyPressed then
    begin
    o:=ed_key_proc(xreadkey);
    ofn:=FN_default;
    nastavAktualniFont(hlavni_font);
    if po_kl_rozpr and (o.ascii<>0) then ZkusZrusitRozpr;
    case o.ascii of
       xLsipka:KrokZpet;
       xPsipka:KrokVpred;
       xDSipka:SipkaDolu;
       xHsipka:SipkaNahoru;
       xDel:KlavesaDel;
       xEnter:KlavesaEnter;
       xEndk:KlavesaEnd;
       xHome:KlavesaHome;
       xPGDN:KlavesaPGDN;
       xPGUP:KlavesaPGUP;
       xCtrlPgUp:KlavesaCtrlPGUP;
       xCtrlPgDn:KlavesaCtrlPGDN;
       xESC:stav:=_deaktivace;
       8{BackSpace}:BackSpace;
       {byte('<'):begin ks:='<<'#0;ksd:=2;end;
       byte('>'):begin ks:='>>'#0;ksd:=2;end;}
       else{case o}
       if mimoradne_osetreni_klavesnice=nil then
          if (o.ascii<256) and (o.ascii>31) then  {ochrana proti CTRL-neco a ALT-neco}
             begin
             if unicode then
                begin
                ks:=Word2UTF8(PrelozZnak(o.ascii,utf8_tbl^))+#0;
                ksd:=Length(ks)-1;
                end
                else begin ks:=char(o.ascii)+#0;ksd:=1;end;
             end else
          else begin
          ks:=mimoradne_osetreni_klavesnice(o);
          ksd:=Length(ks)-1
          end;
       end;{case o}
    kp:=@ks;inc(kp);

    if (ks<>'') and povolene_zmeny then
       begin
       kp:=@ks;inc(kp);
       PridejTextNaPoziciKurzoru(kp,ksd);
       end;

    NastavAktualniFont(ofn);
    if o.ascii<>0 then
       begin
       if po_kl_rozpr then po_kl_rozpr:=false;
       chceme_zobrazit:=true;
       end;
    end{if xKeyPressed}
    else
    if py^.probehni then chceme_zobrazit:=true;
End;


Function TEditacniPole.UkazatelNaRadku(n:longint):PUzel;
begin
UkazatelNaRadku:=radky^.Uzel(n);
end;


Procedure TEditacniPole.OverPoziciKurzorovehoBodu(var kur:TKurPoz);
var v:PItRadek;
begin
if kur.y>Radky^.pocet then
   begin
   kur.y:=Radky^.Pocet;
   kur.r:=tot_posl;
   v:=tot_posl^.vazba;
   kur.x:=v^.up+1;
   Exit;
   end;

v:=kur.r^.vazba;
if kur.x>v^.up+1 then kur.x:=v^.up+1;
end;


Procedure TEditacniPole.SmazRadku(var poz:TKurPoz);
begin
SmazRadku(poz,true);
end;


Procedure TEditacniPole.SmazRadku(var poz:TKurPoz;moznosunout:boolean);
{Kur je pozice na ktere se smaze radek (t.j. bud poloha kurzoru nebo jina
 pozice)}
var v:PItRadek;
    a,b,y1,y2:longint;
    sunout:boolean;
    p:PUzel;
begin
v:=poz.r^.vazba;
y1:=v^.y1;
y2:=v^.y2;
v^.Done;
if Radky^.Pocet=1 then
   begin
   v^.Init;     {jestli existuje jen 1 radka, tak ji proste smazu}
   {v^.y1:=y1;
   v^.y2:=y2;}

   v^.y1:=0;
   v^.y2:=Vyska_FN_default-1;
   v^.yy:=1;

   pozice.r^.vazba:=v;  {zalozim novou}
   pozice.x:=1; {a nastavim kurzor na zacatek radky}
   end
   else begin
   v:=poz.r^.vazba;
   Dispose(v,Done);
   if poz.y=pozice.y then b:=0 else
   if poz.y>pozice.y then b:=1 else b:=2;

   if poz.r=tot_posl then        {jsme na posledni radce?}
      begin
      poz.r:=poz.r^.predchozi;
      tot_posl:=poz.r;
      dec(poz.y);
      Radky^.ZrusUzel(poz.r^.dalsi);
      sunout:=false;
      end
      else begin
      poz.r:=poz.r^.dalsi;
      Radky^.ZrusUzel(poz.r^.predchozi);
      sunout:=true;
      end;


   if b=0 then
      begin
      v:=poz.r^.vazba;
      poz.x:=Pozice_v_retezci_IT(kx,poc_zobrX,v,nil);
      pozice:=poz;
      end else   {kurzor je na mazanem radku}
   if b=2 then dec(pozice.y);     {kurzor je pod mazanym radkem}


   if sunout and moznosunout then
      begin
      if (zalamuj=false) or (poz.y=1)
         then PosunRadek(poz.r)
         else PreskladejRadky(poz);
      end;
   end;
end;


Procedure TEditacniPole.SmazCastRadky(poz1,poz2:TKurpoz);
var v:PItRadek;
    p:PUzel;
begin
if poz1.x=poz2.x then Exit;
v:=poz1.r^.vazba;
v^.Vyjmi(poz1.x,poz2.x-poz1.x);
if pozice.y=poz1.y then
   if pozice.x>poz2.x then dec(pozice.x,poz2.x-poz1.x+1)
      else if (pozice.x>poz1.x) and (pozice.x<=poz2.x) then pozice.x:=poz1.x;

if zalamuj=true then PreskladejRadky(poz1);
end;


Procedure TEditacniPole.SmazSlovo;
var v:PItRadek;
    a,b,n:longint;
    p,p2:pchar;
    c:char;
begin
v:=pozice.r^.vazba;
if v^.up=0 then Exit;
VratSlovo_FN_p(v^.p,pozice.x,a,b);
v^.Vyjmi(a,b-a+1);
if a<>b then
   begin
   pozice.x:=a;
   p:=v^.p;
   inc(p,a-1);
   c:=p^;
   p^:=#0;
   n:=UniLength(v^.p);
   p^:=c;
   if zalamuj=true then PreskladejRadky(pozice);
   end;
end;


Procedure TEditacniPole.SmazBlokTextu(zac,kon:TKurPoz);
var v:PItRadek;
    temp,temp2:TKurPoz;
    z:boolean;
    b:byte;
    i,j:longint;
    p:PUzel;

begin
v:=zac.r^.vazba;
if zac.y=kon.y then
   begin
   if (zac.x=1) and (kon.x=v^.up+1)
      then begin SmazRadku(zac);Exit;end
      else begin SmazCastRadky(zac,kon);Exit;end;
   end
   else begin
   z:=zalamuj;
   zalamuj:=false;


   {Napred smazu vsechny zarucene kompletni radky}
   i:=kon.y-zac.y;
   if i>=2 then
      for j:=1 to i-1 do
          begin {mazani kompletnich radek mezi startovni a cilovou pozici}
          temp:=zac;
          inc(temp.y);
          temp.r:=zac.r^.dalsi;
          v:=temp.r^.vazba;
          dec(kon.y);
          SmazRadku(temp,false);
          end;
   {zbyva pocatecni radek a koncovy radek}
   if zac.x=1 then
      begin
      temp:=zac;
      zac.r:=zac.r^.predchozi;
      v:=temp.r^.vazba;
      SmazRadku(temp,false);
      dec(kon.y);
      end
      else begin
      temp:=zac;
      v:=temp.r^.vazba;
      temp.x:=v^.up+1;
      SmazCastRadky(zac,temp);
      end;

   {zbyva posledni radek}
   v:=kon.r^.vazba;
   if kon.x>=v^.up+1 then
      begin
      temp:=kon;
      kon.r:=kon.r^.dalsi;
      v:=temp.r^.vazba;
      SmazRadku(temp,false);
      end
      else begin
      temp:=kon;
      temp.x:=1;
      SmazCastRadky(temp,kon);
      end;

   zalamuj:=z;
   if kon.r=nil then
      begin
      VycentrujNaKurzor;
      Exit;  {byla smazana i cela posledni radka?}
      end;

   if zalamuj=true then PreskladejRadky(zac,true,false,true)
      else begin

         if zac.x>1 then
            begin
            v:=kon.r^.vazba;
            temp.r:=kon.r^.dalsi;
            Prilep_K_predeslemu(kon.r,false);
            kon.r:=temp.r;
            if kon.r=nil then
               begin
               VycentrujNaKurzor;
               Exit;
               end;
            end;

         PosunRadek(kon.r);

         {Pozor, muze hybat s promennou POZICE}
      end;
   end;
VycentrujNaKurzor;
byla_zmena:=true;
end;


Procedure TEditacniPole.VlozTextNaPozici(blok:PVaznik;poz:TKurPoz);
var v1,v2,v3,v4:PItRadek;
    p,r,t,u:PUzel;
    gd,kk,kl,n:longint;
    temp:TKurPoz;

begin
p:=blok^.first;

{napred vlozim radku textu na radku, kde je kurzor
(tzn. nezakladam nove radky)}
v1:=p^.vazba;
r:=poz.r;
v2:=r^.vazba;
v2^.VlozKusIT(v1,poz.x,1,v1^.delka);

v3:=v2;
p:=p^.dalsi;
if p=nil then Exit;  {Kopiruje se jen jeden radek? V tom pripade jsme hotovi}

{ted preskocim na posledni radek}
n:=1;
kk:=0;
temp:=poz;
inc(temp.x,v1^.up);
RozdelRadku(temp,kl);   {vznikla nova radka (je na ni cast predchozi radky)}
inc(kk,kl);
v2:=r^.dalsi^.vazba;
t:=blok^.Last;    {pripravim si posledni radku bloku}
v1:=t^.vazba;
v2^.VlozKusIT(v1,1,1,v1^.delka);
if p<>t then {Kopirovaly se jen dva radky?}
   while p<>t do
      begin         {ted uz budu muset zakladat nove radky}
      v1:=p^.vazba;
      v2:=New(PItRadek,Init);
      v2^.VlozKusIT(v1,1,1,v1^.delka);
      v2^.yy:=v3^.yy+1;
      v2^.y1:=v3^.y2+1;
      v2^.y2:=v2^.y1+(v3^.y2-v3^.y1);

      u:=Radky^.InsertNew(r,v2);
      v3:=v2;
      r:=u;
      p:=p^.dalsi;
      end;

v4^.yy:=v3^.yy+1;
v4^.y1:=v3^.y2+1;
v4^.y2:=v4^.y1+(v3^.y2-v3^.y1);

if r^.dalsi=tot_posl then Exit;

if zalamuj=false
   then PosunRadek(r^.dalsi^.dalsi)
   else PreskladejRadky(poz);
end;


Procedure TEditacniPole.vert_VycentrovaniKurzoru;
var v:PItRadek;
begin
v:=pozice.r^.vazba;
if (v^.y1<poc_zobrY) or (v^.y2>poc_zobrY+virt^.hoehe) then
   poc_ZobrY:=v^.y1-virt^.hoehe div 2;
if poc_ZobrY<0 then poc_ZobrY:=0;
end;

Procedure TEditacniPole.horz_VycentrovaniKurzoru;
var v:PItRadek;
    c:char;
    xx:longint;
begin
v:=pozice.r^.vazba;
xx:=Sirka_FN_na_Xpoz(v^.p,nil,pozice.x);
if zalamuj=false then
   begin
   poc_ZobrX:=-(xx-virt^.breite div 2);
   if poc_ZobrX>-100 then poc_ZobrX:=4;
   end;
end;

Procedure TEditacniPole.VycentrujNaKurzor;
{jestlize nejaky jiny proces nastavil promenou POZICE a je treba zajistit,
aby tato pozice byla v zobrazovanem useku.}
begin
vert_VycentrovaniKurzoru;
horz_VycentrovaniKurzoru;
end;

Procedure TEditacniPole.BlikejKurzorem;
    Function ProvedClippingVertikalniCary(var k1_,k2_:longint;y1_,y2_:longint):boolean;
    begin
    if k2_<y1_ then Exit(false);
    if k1_>y2_ then Exit(false);
    if k1_<y1_ then k1_:=y1_;
    if k2_>y2_ then k2_:=y2_;
    ProvedClippingVertikalniCary:=true;
    end;

var b,n:boolean;
    kyy1,kyy2:longint;
begin
{if prinutit and (kkx<>-1) then PutSprite(cil^,kpoz,kkx,kky);}
if povolene_zmeny=false then Exit;
kpoz.hoehe:=kd;
kkx:=kx+x;
kky:=ky-poc_ZobrY+y;

kyy1:=kky;
kyy2:=kky+kd-1;

b:=ProvedClippingVertikalniCary(kyy1,kyy2,y,y+vyska-1);
if b=false then Exit;

if je_videt then
   begin
   {kpoz.hoehe:=20;}
   n:=PrunikMysi(kkx,kyy1,kkx,kyy2);
   if N then mousehide;
   GetClippedSprite(cil^,kpoz,kkx,kyy1);
   LineClipped(cil^,kkx,kyy1,kkx,kyy2,BB_txt_txt);
   if N then mouseshow;
   end
   else begin
   n:=PrunikMysi(kkx,kyy1,kkx,kyy2);
   if N then mousehide;
   PutClippedSprite(cil^,kpoz,kkx,kyy1);
   if N then mouseshow;
   end;
end;

Procedure TEditacniPole.ZhasniKurzor;
begin
if je_videt then
   begin
   je_videt:=false;
   BlikejKurzorem;
   end;
end;

Procedure TEditacniPole.RozsvitKurzor;
begin
if je_videt=false then
   begin
   je_videt:=true;
   BlikejKurzorem;
   end;
end;

Function TEditacniPole.PismenoZpet:longint;
var p,i,j:longint;
begin
p:=poc_ZobrX;
i:=pozice.x;
KrokZpet;
PismenoZpet:=pozice.x;
pozice.x:=i;
poc_ZobrX:=p;
end;

Procedure TEditacniPole.Zobraz;
   Procedure EdPrint_Vaznik_ROZPR;
   {VOLA SE V PRIPADE POSUVNIKO-KLAVESOVEHO ROZPORU - NEOPTIMALIZOVANO}
   var v,kv:PItRadek;
       p:PUzel;
   begin
   po_kl_jsme_mimo:=true;
   p:=radky^.first;
   while p<>nil do   {napred preskocim radky, ktere jsou nad vyrezem}
      begin v:=p^.vazba;if v^.y2-poc_ZobrY>0 then Break;p:=p^.dalsi;end;
   prv_rad:=p;
   while p<>nil do
      begin
      v:=p^.vazba;
      if v^.y1-poc_zobrY>=virt^.hoehe then Break;
      if p=po_kl_pozice.r then
         po_kl_jsme_mimo:=false;  {radek s kurzorem byl vypsan i v tomto rezimu}
      {SetBasicLine(v^.y1-poc_ZobrY);
      Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.up,nil);}

      Print_IT(poc_zobrX,v^.y1,v);

      posl_rad:=p;
      p:=p^.dalsi;
      end;
   end;

   Procedure EDPrint_Vaznik_NORM;
   {VOLA SE POKUD NIKDO NEHRABAL NA POSUVNIK - JE RYCHLEJSI}
   var v:PItRadek;
       i:longint;
       b:boolean;
       p:PUzel;
   begin
   {Zvlastnosti teto procedury je, ze nepise radky po sobe}
   i:=pozice.y;
   v:=pozice.r^.vazba;
   {napred vypisu radek, na kterem je kurzor}
   FN_poloha[0].B:=URCIZNAK;     {budu chtit znam polohu aktualniho znaku na obrazovce}

   FN_poloha[0].N:=pozice.x-1;     {(stejne jako jeste dalsi podobne veci)}

   {SetBasicLine(v^.y1-poc_ZobrY);
   Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.up,nil);}

   Print_IT(poc_zobrX,v^.y1,v);

   prv_rad:=pozice.r;   {napred predpokladam, ze to je prvni viditelna radka}
   posl_rad:=pozice.r;  {a ze je to taky posledni viditelna radka}

   ky:=v^.y1;
   if pozice.x=1 then
      kx:=poc_zobrX else kx:=FN_poloha[0].x; {polohu zname, takze tam umistime kurzor}
   kd:=v^.y2-v^.y1+1;
   PozText.doz:=v^.doz;
   PozText.odz:=v^.odz;
   PozText.posunv:=v^.posunv;
   PozText.posunm:=v^.posunm;
   {ted vypisu radky pod kurzorem - ovsem jenom ty, co se vejsou na obrazovku}
   p:=pozice.r^.dalsi;
   while p<>nil do
      begin
      v:=p^.vazba;
      if v^.y1-poc_ZobrY<virt^.hoehe then
         begin
         {SetBasicLine(v^.y1-poc_ZobrY);
         Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.up,nil);}

         Print_IT(poc_zobrX,v^.y1,v);

         posl_rad:=p;
         end
         else begin
         posl_rad:=p^.predchozi;  {zapamatuje si posledni zcela viditelnou radku}
         Break;
         end;
      p:=p^.dalsi;
      end;

   {a nad kurzorem - zase jenom ty, co se vejsou na obrazovku}
   p:=pozice.r^.predchozi;
   while p^.predchozi<>nil do
      begin
      v:=p^.vazba;
      if v^.y2-poc_ZobrY>0 then
         begin
         {SetBasicLine(v^.y1-poc_ZobrY);
         Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.up,nil);}

         Print_IT(poc_zobrX,v^.y1,v);

         prv_rad:=p;        {zapamatuje si prvni viditelnou radku}
         end
         else begin
         Break;
         end;
      p:=p^.predchozi;
      end;
   end;

{===================== HLAVNI TELO PROCEDURY ZOBRAZ =========================}
var skutecna_sirka:longint;
    i,ll:longint;
    v:PItRadek;
begin
Ufon;
{ZkontrolujYY;}
FN_color:=BB_txt_txt;
NastavVystup(virt);
{SetBasicLine(poc_zobrY);
ll:=GetLastLine;
SetLastLine(virt^.hoeheminus1);}

if po_kl_rozpr then EdPrint_Vaznik_ROZPR
               else EdPrint_Vaznik_NORM;
{SetLastLine(ll);}
MouseLock;
MouseSelfCopy(virt^,x,y);
PutSprite_and_clear(cil^,virt^,x,y,BB_txt_v);
MouseUnLock;

if (stav<>_deaktivace) then
   begin
   je_videt:=true;
   puvodni_citac:=FromTimer;
   BlikejKurzorem;
   end;

{mouseshow;}
py^.hodnota:=poc_ZobrY;
v:=tot_posl^.vazba;
py^.virtvyska:=v^.y2;
py^.Zobraz;
NastavVystup(cil);

ED_Zobr_proc;

Ofon;
end;


Procedure TEditacniPole.ZmenBarvuPozadi(w:word);
begin
BB_txt_v:=w;
Clr(virt^,BB_txt_v);
end;


Procedure TEditacniPole.EP_ZavriSoubor;
var v:PItRadek;
    i:dword;
begin
i:=0;
while radky^.first<>nil do
    begin
    inc(i);
    v:=radky^.first^.vazba;
    if v<>nil then dispose(v,Done); {V by ale melo byt prirazeno vzdy...}
    Radky^.ZrusUzel(radky^.first);
    end;
end;

Procedure TEditacniPole.NovySoubor;
var v:PItRadek;
    i:longint;
begin
ufon;
EP_ZavriSoubor;
v:=New(PItRadek,Init);
v^.y1:=0;
i:=Vyska_FN_default-1;
v^.y2:=i;
v^.yy:=1;
radky^.InitNext(v);
SkocNaZacatek;
tot_posl:=pozice.R;
byla_zmena:=false;
ofon;
end;

Procedure TEditacniPole.EP_PridejVetsi(v:PItRadek);
var k,u,n:longint;
    r:real;
    tbm:string;

begin
k:=0;
n:=v^.up;
while k<=n do
   begin
   if v^.p[k]='<' then
      begin
      v^.vloz('<',1,k+1);
      inc(k,2);
      inc(n);
      end else
   if v^.p[k]='>' then
      begin
      v^.vloz('>',1,k+1);
      inc(k,2);
      inc(n);
      end else
   if v^.p[k]=#9 then {rozklad tabulatoru na mezery}
      begin
      v^.vyjmi(k+1,1);
      u:=(k+1) mod tab_na_mezery;
      u:=tab_na_mezery-u+1;
      tbm:=XMezer(u);
      v^.vlozS(tbm,k+1);
      inc(n,u-1);
      end
      else begin
      if v^.p[k]>#127 then
      {Detekce, je-li soubor v unicode ci, jsou-li to 8-bitove narodni znaky}
         begin
         inc(prac1);
         if v^.p[k]<#224 then
            if k<n then if (v^.p[k+1]>#127) and (v^.p[k+1]<#192) then
               begin inc(k);inc(prac2);end
            else else else {>224 tzn. 3bajtove znaky}
            if k-1<n then if (v^.p[k+1]>#127) and (v^.p[k+1]<#192) and (v^.p[k+1]>#127) and (v^.p[k+1]<#192) then
               begin inc(k,2);inc(prac2);end;
         end;
      inc(k);

      end;
   end;
end;

Procedure TEditacniPole.EP_UberVetsi(v:PItRadek);
var k,l:longint;
begin
l:=v^.up;
k:=0;
while k<=l do
   begin
   if (v^.p[k]='<') {and (hodnota[k+1]='<')} then
      begin
      v^.vyjmi(k+1,1);
      dec(l);
      end else
   if (v^.p[k]='>') {and (hodnota[k+1]='<')} then
      begin
      v^.vyjmi(k+1,1);
      dec(l);
      end;
   inc(k);
   end;
end;


Procedure TEditacniPole.NastavRozmeziRadku(v:PItRadek;var yz:longint);
begin
if jednotna_vyska_radku then
   begin
   v^.y1:=yz;
   v^.y2:=yz+vyska_fn(NastavenyFont)-1;
   yz:=v^.y2+1;
   end
   else begin
   v^.y1:=yz;
   v^.y2:=v^.y1+RychlaVyskaRadky(v^.p);
   yz:=v^.y2+1;
   end;
end;


Procedure TEditacniPole.UpravRozmeziRadku(v:PItRadek;var yz:longint);
begin
if jednotna_vyska_radku=false then
   begin
   v^.y2:=v^.y1+RychlaVyskaRadky(v^.p);
   yz:=v^.y2+1;
   end;
end;



Procedure TEditacniPole.PridelRadky;
var p:PUzel;
    v:PItRadek;
    vfn,pryy,i:longint;
    f:pfont;
begin
nastavaktualnifont(hlavni_font);
vfn:=Vyska_FN(AktualniFont);
ofn:=fn_default;

i:=0;
pryy:=0;
p:=radky^.first;
while p<>nil do
   begin
   v:=p^.vazba;
   inc(pryy);
   NastavRozmeziRadku(v,i);  {nastavi v^.y1 a v^.y2 a upravi I}
   v^.yy:=pryy;
   p:=p^.dalsi;
   end;
nastavaktualnifont(ofn);
if zalamuj then NalamejBuffer(radky^.first);
end;


Procedure TEditacniPole.PosunRadek(p:PUzel);
{Nesnazi se zjistovat vysku radek, ale proste upravi jejich Y1 a Y2 a YY aby
 na sebe navazovaly}
var v,w:PItRadek;
begin
if p^.predchozi=nil then Error('Error in TEditacniPole.PosunRadky!','');
{jsme na nultem radku? Tak to je chyba.}

if p^.predchozi^.predchozi=nil then  {jsme na prvnim radku? To muze byt.}
   begin
   v:=p^.vazba;
   v^.yy:=1;
   v^.y2:=v^.y2-v^.y1;
   v^.y1:=0;
   p:=p^.dalsi;
   end;

while p<>nil do     {Ted zpracuji dalsi radky}
   begin
   v:=p^.vazba;
   w:=p^.predchozi^.vazba;
   v^.yy:=w^.yy+1;
   v^.y2:=v^.y2-v^.y1+w^.y2+1;
   v^.y1:=w^.y2+1;
   p:=p^.dalsi;
   end;
end;


Procedure TEditacniPole.PreskladejRadky(poz:TKurPoz);
begin
PreskladejRadky(poz,true,true,true);
end;


Procedure TEditacniPole.PreskladejRadky(poz:TKurPoz;m1,m2,m3:boolean);
var p:PUzel;
    v:PItRadek;
begin
p:=poz.r^.predchozi;
v:=p^.vazba;

if not v^.crlf then
   begin
   Prilep_k_predeslemu(p^.dalsi,m1); {eventualni spojeni s hornim radkem}
   end
   else begin
   p:=poz.r;
   v:=p^.vazba;
   end;

if not v^.crlf then Prilep_k_predeslemu(p^.dalsi,m2);
while not v^.crlf do Prilep_k_predeslemu(p^.dalsi,m3);

v^.gd:=virt^.breite;
if p^.predchozi^.predchozi<>nil then p:=p^.predchozi;
NalamejBuffer(p);
end;



Procedure TEditacniPole.NalamejBuffer(pr:PUzel);
var v,v2,nv:PItRadek;
    p,novy:PUzel;
    a,i,l,oi,pryy,yz,vrad:longint;
    d1,d2,d3,d4:longint;
    dbg:string;
    f:pfont;
begin
p:=pr;
v:=p^.vazba;
yz:=v^.y1;
pryy:=v^.yy;
ofn:=fn_default;
NastavAktualniFont(hlavni_font);

while p<>nil do
   begin
   v:=p^.vazba;
   NastavRozmeziRadku(v,yz); {YZ se automaticky inkrementuje}
   v^.yy:=pryy;
   if v^.gd>virt^.breiteminus1-poc_ZobrX then {radka je sirsi nez okno?}
      begin
      i:=Pozice_v_retezci_IT(virt^.breiteminus1,poc_ZobrX,v,nil);
      if i<v^.delka then
         begin               {dlouha radka - bude treba zalamovat}
         oi:=i;
         v^.smezerou:=true;

         {pujdu zpatky a budu hledat mezeru}
         while v^.p[i-1]<>' ' do
            if i=1 then begin i:=oi;v^.smezerou:=false;Break;end else dec(i);
         {I je ted na posledni mezere od predchoziho slova}
         if v^.smezerou then l:=1 else l:=0;

         nv:=New(PItRadek,Init);
         v^.Rozdel(nv^,i,l);

         a:=FN_skut_znak;
         UpravRozmeziRadku(v,yz);  {eventualne prenastavi v^.y2 a YZ}

         v^.crlf:=false;     {radek uz neni ukoncen natvrdo pomoci CRLF, ale je ukoncen pruzne}
         dec(i,l);
         novy:=Radky^.InsertNew(p,nv);
         if pozice.y=v^.yy then
            begin
            if pozice.x>i then {nemuze tu byt >=}
               begin
               v2:=posl_rad^.vazba;
               if v^.y2+RychlaVyskaRadky(v^.p)-Poc_ZobrY>virt^.hoeheminus1
                  then inc(poc_ZobrY,vyska_fn(f)+1);
               pozice.y:=pozice.y+1;
               pozice.x:=pozice.x-i-1;

               {Sirka_FN_na_Xpoz(nv^.p,nil,pozice.x);}

               pozice.r:=novy;
               end;
            end;

         if posledni_vyskyt.y=v^.yy then posledni_vyskyt.r:=nil;

         end
         else begin          {radka se na obrazovku preci jen vejde - nebudu zalamovat}
         v^.crlf:=true;
         end;
      end;
   inc(pryy);
   tot_posl:=p;
   p:=p^.dalsi;
   end;
if pozice.x=0 then pozice.x:=1; {vojeb, spravne by nemelo nikdy nastat}
nastavaktualnifont(ofn);
end;


Procedure TEditacniPole.PospojujRadky;
var p:PUzel;
    v:PItRadek;
    i,j:longint;
begin
i:=0;
j:=Vyska_FN(AktualniFont);
p:=radky^.first;
while p<>nil do
   begin
   v:=p^.vazba;
   while v^.crlf=false do
      Prilep_k_predeslemu(p^.dalsi,true); {druhy radek prilepi k prvnimu}
   v^.y1:=i;
   v^.y2:=i+j-1;
   inc(i,j);
   tot_posl:=p;
   p:=p^.dalsi;
   end;
end;

Procedure TEditacniPole.ZmenFont(s:string);
var a,b:longint;
    p:PUzel;
    v:PItRadek;
    f:pfont;
begin
if zalamuj then
   begin
   PospojujRadky;
   {hlavni_font:=s;}NastavAktualniFont(s);



   NalamejBuffer(radky^.first);
   end else
   begin
   p:=radky^.first;
   hlavni_font:=s;
   f:=Nacti_FNSLR(s);
   b:=vyska_fn(f);
   a:=0;
   while p<>nil do
      begin
      v:=p^.vazba;
      v^.y1:=a;
      v^.y2:=a+b-1;
      inc(a,b);
      v^.gd:=Sirka_IT(v);
      p:=p^.dalsi;
      end;
   end;
end;

Procedure SrovnejYYradek(p:PVaznik);
var v:PItRadek;
    i:longint;
    n:PUzel;
begin
i:=0;
n:=p^.first;
while p<>nil do
   begin
   inc(i);
   v:=n^.vazba;
   v^.yy:=i;
   n:=n^.dalsi;
   end;
end;

Function TEditacniPole.DejLinearniPozici:longint;
var p:PUzel;
    v:PItRadek;
    i:longint;
begin
i:=0;
p:=radky^.first;
while p<>pozice.r do
   begin
   v:=p^.vazba;
   i:=i+v^.up+1;
   p:=p^.dalsi;
   end;
i:=i+pozice.x;
DejLinearniPozici:=i;
end;

Procedure TEditacniPole.NastavLinearniPozici(i:longint);
var p:PUzel;
    v:PItRadek;
    j,k:longint;
begin
j:=0;
k:=1;
p:=radky^.first;
while p<>nil do
   begin
   v:=p^.vazba;
   if j+v^.up+1>i then break else inc(j,v^.up+1);
   inc(k);
   p:=p^.dalsi;
   end;
pozice.r:=p;
pozice.y:=k;
pozice.x:=i-j;
if pozice.x=0 then pozice.x:=1; {vojeb, nemelo by nikdy nastat}
end;

Procedure TEditacniPole.PosouvaciRezim;
var i:longint;
begin
i:=DejLinearniPozici;
zalamuj:=false;
PospojujRadky;
SrovnejYYradek(radky);
NastavLinearniPozici(i);
{SkocNaZacatek;}
VycentrujNaKurzor;
end;

Procedure TEditacniPole.ZalamovaciRezim;
var i:longint;
begin
i:=DejLinearniPozici;
zalamuj:=true;
NalamejBuffer(radky^.first);
NastavLinearniPozici(i);
{SkocNaZacatek;}
VycentrujNaKurzor;
end;

Procedure TEditacniPole.SkocNaZacatek;
begin
poc_ZobrX:=4;
poc_ZobrY:=0;
pozice.x:=1;
pozice.y:=1;
pozice.r:=radky^.first;
end;

Function TEditacniPole.NactiZeStreamu(var s:TStream):byte;
const BUFFER = 65536;
var l,m,k:longint;
    p:pchar;
    r:PUzel;
    v:PItRadek;
    postup,pokracovat:boolean;

begin
ufon;
MouseSetCursor(UKmysCekej);
l:=s.GetSize;
if l=0 then
   begin
   ofon;
   NovySoubor;
   MouseSetCursor(UKmys);
   NactiZeStreamu:=edna_OK;
   Exit;
   end;
MyGetMem(p,BUFFER+1);
EP_ZavriSoubor;         {Odstrani prave nactenou vec}
tot_posl:=nil;
pokracovat:=true;
postup:=l>=BUFFER*10;

repeat
l:=s.GetPos;               {zaznamenam pozici ve streamu pred ctenim}
s.Read(p^,BUFFER);        {pokusim se precist VELBUF bajtu}
if s.status<>stOK then  {nedoslo ke cteni za koncem souboru?}
   begin
   s.reset;                {resetuj chybovy stav}
   l:=s.GetSize-l;         {a zjisti, jak velky byl tento posledni usek}
   s.Read(p^,l);           {udelam tedy druhy pokus o nacteni}
   end
   else l:=s.GetPos-l;     {o kolik bajtu jsme se soupli?}
if l<>0 then
   begin
   if p[0]=#10 then m:=1 else m:=0;  {kdyz minuly blok skoncil #13 a na zacatku }                                  {tohodle by z CRLF zustalo #10}
   repeat
      k:=IndexByte(p[m],l,13);    {budu hledat #13 - tedy Enter}
      if k=-1 then
         begin
         DalsiRadka(p,m,false);
         m:=l;
         end;

      if k<>-1 then
         begin
         {Ted by nebylo od veci zkontrolovat, jesli se v tomhle useku nevyskytuje
         znak #0 a v tom pripade ho nahradit mezerou}
         p[m+k]:=#0;           {znak #13 nahradim znakem #0}
         DalsiRadka(p,m,true);
         if p[m+k+1]=#10 then inc(m,k+2) else inc(m,k+1);
         end;
   until m>=l;
   if postup and (ukaz_postup_nahravani<>nil) then
      begin
      pokracovat:=Ukaz_Postup_Nahravani(s.GetPos/s.GetSize*100);
      if pokracovat=false then
         begin
         ofon;
         NovySoubor;
         MouseSetCursor(UKmys);
         FreeMem(p,BUFFER+1);
         NactiZeStreamu:=edna_CANCELED;
         Exit;
         end;
      end;
   end;
until l<>BUFFER;
if postup and (ukaz_postup_nahravani<>nil) then
   Ukaz_Postup_Nahravani(-1);
DalsiRadka(nil,0,true);     {ukoncime pripadnou rozdelanou radku}
FreeMem(p,BUFFER+1);
SkocNaZacatek;
MouseSetCursor(UKmys);
NactiZeStreamu:=edna_OK;
if zalamuj then NalamejBuffer(pozice.r);
ofon;
end;

Procedure TEditacniPole.DalsiRadka(u:PChar;poz:longint;ukoncena:boolean);
var k,y1,yy:longint;
    v,e:PItRadek;
    b:boolean;
begin
if tot_posl<>nil then
   begin
   e:=tot_posl^.vazba;
   y1:=e^.y2+1;
   yy:=e^.yy+1;
   b:=e^.smezerou;     {je predchozi radek ukoncen?}
   end
   else begin
   y1:=0;yy:=1;
   tot_posl:=radky^.first;
   b:=true;
   end;
if u<>nil then inc(u,poz);
if B then {delame uplne novy radek}
   begin
   if u=nil then Exit;
   v:=New(PItRadek,Init);
   v^.Vloz(u,PLength(u),1);
   v^.smezerou:=ukoncena;
   if ukoncena then
      begin
      if konverze_tagu then EP_PridejVetsi(v);
      end;
   if jednotna_vyska_radku=true
      then k:=RychlaVyskaRadky('')
      else k:=RychlaVyskaRadky(v^.p);
   v^.y1:=y1;
   v^.y2:=y1+k-1{?};
   v^.yy:=yy;

   tot_posl:=Radky^.InsertNew(tot_posl,v);
   end
   else begin
   if u<>nil then e^.Vloz(u,PLength(u),e^.up+1);
   e^.smezerou:=ukoncena;
   if ukoncena then
      begin
      if konverze_tagu then EP_PridejVetsi(e);
      end;
   end;
end;

Function TEditacniPole.NactiZVazniku(p:PVaznik):boolean;
var pp,q,r:PUzel;
    u:PChar;
    v:PString;
    z:string;
    i:longint;
    e:PItRadek;
begin
EP_ZavriSoubor; {Odstrani prave nactenou vec}
tot_posl:=nil;
pp:=p^.first;
u:=pp^.vazba;
Move(u^,z,4);
z[0]:=#3;
if z='#*#' then        {pro jednoradkove textiky}
   begin
   v:=pointer(u);
   z:=v^;
   delete(z,1,4);
   i:=Pos('#',z);
   delete(z,1,i+1);
   z:=z+#0;
   u:=@z[1];
   DalsiRadka(u,0,true);
   end
   else begin          {pro viceradkove texty}
   pp:=pp^.dalsi;
   while pp<>nil do
      begin
      v:=pp^.vazba;
      z:=v^+#0;
      u:=@z[1];
      DalsiRadka(u,0,true);
      pp:=pp^.dalsi;
      end;
   end;
SkocNaZacatek;
zalamuj:=true;
NalamejBuffer(pozice.r);
Zobraz;
end;

Function TEditacniPole.NactiSoubor(s:string):byte;
var t:TBufStream;
begin
if not ExistFile(s) then Exit(edna_NOFILE);
t.Init(s,stOpenRead,32768);
NactiSoubor:=NactiZeStreamu(t);
byla_zmena:=false;
t.Done;
end;

Function TEditacniPole.UlozDoStreamu(var s:TStream):boolean;
var p:pointer;
    r:PUzel;
    v:PItRadek;
    m,l,k:longint;
    crlf:word;
    mz:char;
begin
crlf:=$0a0d;
mz:=' ';
MouseSetCursor(UKmysCekej);
r:=radky^.first;
while r<>nil do
   begin
   v:=r^.vazba;
   if v^.up+1>1 then
      begin
      if konverze_tagu then EP_UberVetsi(v);
      l:=v^.up;      {nepocitam ukoncovaci #0}
      s.Write(v^.p^,l);
      if konverze_tagu then EP_PridejVetsi(v);
      end;
   if v^.crlf then s.Write(crlf,2) else s.Write(mz,1);
   r:=r^.dalsi;
   end;
MouseSetCursor(UKmys);
UlozDoStreamu:=true;
end;

Function TEditacniPole.UlozSoubor(s:string):boolean;
var t:TMemoryStream;
    t2:TBufStream;
    b:longint;
    d1,e2,e3:string;
begin
s:=FExpand(s);
Fsplit(s,d1,e2,e3);     { chceme adresar, jmeno a priponu cile }
if not ExistDir(d1) then
   begin
   b:=MakeDir(d1);  { testneme zacatek cesty }
   if b<>0 then Exit(false);
   end;
t.Init(40000,20000);
UlozSoubor:=UlozDoStreamu(t);
t.seek(0);
t2.Init(s,stCreate,40000);
if t2.ErrorInfo<>0 then
   begin t.Done;t2.Done;Exit(false);end;

t2.CopyFrom(t,t.GetSize);
if t2.ErrorInfo<>0 then
   begin t.Done;t2.Done;Exit(false);end;
t.Done;
t2.Done;
byla_zmena:=false;
UlozSoubor:=true;
end;

Function TEditacniPole.ZkontrolujYY:boolean;
var p:PUzel;
    v:PItRadek;
    a:longint;

    s:string;
    yy,_yy,yy_:longint;
begin
ZkontrolujYY:=true;
a:=0;
p:=radky^.first;
while p<>nil do
   begin
   v:=p^.vazba;
   if v^.yy=a+1 then inc(a)
      else begin
      s:=v^.p;
      yy:=v^.yy;
      v:=p^.predchozi^.vazba;
      _yy:=v^.yy;
      v:=p^.dalsi^.vazba;
      _yy:=v^.yy;
      end;
   p:=p^.dalsi;
   end;
end;

Destructor TEditacniPole.Done;
begin
kpoz.hoehe:=100;
Kill_VW(kpoz);
Kill_VW(virt^);
EP_ZavriSoubor;
Dispose(radky,done);
end;


Constructor TBlokTextu.Init;
begin
radkybloku:=New(PVaznik,Init);
end;


Procedure TBlokTextu.VlozBlok(zac,kon:TKurPoz);
var v1,v2:PItRadek;
    p1,p2:PUzel;

begin
p1:=zac.r;
v1:=zac.r^.vazba;
p2:=radkybloku^.first;
if zac.x<v1^.up+1 then
   begin

   v2:=New(PItRadek,Init);

   if zac.r=kon.r then  {zacatek i konec vyberu jsou na stejne radce?}
      begin
      v2^.VlozKusIT(v1,1,zac.x,kon.x-zac.x+1);
      v2^.crlf:=false;
      radkybloku^.InitNext(v2);
      Exit;
      end;

   v2^.VlozKusIT(v1,1,zac.x,v1^.delka-zac.x);
   v2^.crlf:=v1^.crlf;
   p1:=p1^.dalsi;
   p2:=radkybloku^.InitNext(v2);
   end;

while p1<>kon.r do {dokud nejsme na cilove radce tak...}
   begin
   v1:=p1^.vazba;
   v2:=New(PItRadek,Init);
   v2^.VlozKusIT(v1,1,1,v1^.delka);
   v2^.crlf:=v1^.crlf;
   p2:=radkybloku^.InitNext(v2);
   p1:=p1^.dalsi;
   end;

{A jeste zbyva zpracovat posledni radku}
if kon.x=1 then Exit;
v1:=p1^.vazba;
v2:=New(PItRadek,Init);
v2^.VlozKusIT(v1,1,1,kon.x-1);
v2^.crlf:=true;
p2:=radkybloku^.InitNext(v2);
end;


Procedure TBlokTextu.SmazObsah;
var v:PItRadek;
begin
if radkybloku^.pocet=0 then Exit;
while radkybloku^.first<>nil do
    begin
    v:=radkybloku^.first^.vazba;
    Dispose(v,Done);
    radkybloku^.ZrusUzel(radkybloku^.first);
    end;
end;


Destructor TBlokTextu.Done;
begin
SmazObsah;
Dispose(radkybloku,Done);
end;


Procedure TextoveOkno(x,y,sirka,vyska:longint;popis:string;p:string);
var e:PEditacniPole;
    ok:pokno_s_textem;
    okt:pTlacitko;
    _o:word;
    i:longint;
begin

ok:=New(POkno_s_textem, Init(x,y,sirka,vyska,popis,'',w_OK,true,true));



e:=New(PEditacniPole,Init(ok^.x+2,ok^.y+30,ok^.sirka-2,i-(ok^.y+30),true));
e^.konverze_tagu:=false;
e^.povolene_zmeny:=false;
e^.jednotna_vyska_radku:=false;
e^.po_kl_rozpr:=true;
{e^.NactiZVazniku(p);}
e^.NactiSoubor(p);

ok^.Retez^.Pridej(e);

ok^.Zobraz;
ok^.Run;
Dispose(ok,Done);


end;

end.
